#ifndef ___KITIKUO_KITIKUODLG_H___
#define ___KITIKUO_KITIKUODLG_H___

#if _MSC_VER > 1000
#pragma once
#endif

class KitikuoDlgC : public CDialog
{
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%																		%%
//%%								@									%%
//%%																		%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
public:
	enum {
		eMinAsdSize		= 0x42000,						//	e\t@CTCYŏl
		eUnit_Num		= 50,							//	
		eName_Length	= 50,							//	̂̍ő啶
		eName_Offset	= 0x96,							//	jbg܂łoffsetíj
		eParam_Offset	= 0x02,							//	jbg܂łoffsetip[^j
		eBudget			= 0x51e,						//	addressF\Z
		eCommander		= 0x450a,						//	addressF
		eSoldier		= 0x453c,						//	addressF
		eU_HP			= 0x41236,						//	addressFm
		eU_MaxHP		= 0x4129e,						//	addressFő啺m
		eU_At			= 0x41306,						//	addressFU
		eU_Df			= 0x4136e,						//	addressFh
		eU_RP			= 0x4150e,						//	addressF񕜐
		eAt				= 0x415de,						//	addressFU
		eDf				= 0x41646,						//	addressFh
		eAtT			= 0x416ae,						//	addressFU
		eHP				= 0x41716,						//	addressFHP
		eMaxHP			= 0x4177e,						//	addressFőHP
		eOp				= 0x417e6,						//	addressF퐬m
		eMg				= 0x4184e,						//	addressF@́^@h
		eRDj_At			= 0x4191e,						//	addressF{_UC
		eRDj_Df			= 0x41986,						//	addressF{_hC
		eFlag			= 0x419ee,						//	addressFtO
		eEx				= 0x41abe,						//	addressF݂̌on
		eLv				= 0x41b26,						//	addressF퓬LV
		eRAt_At			= 0x41d96,						//	addressFU_UC
		eRDf_At			= 0x41dfe,						//	addressFh䎞_UC
		eRAt_Df			= 0x41e66,						//	addressFU_hC
		eRDf_Df			= 0x41ece						//	addressFh䎞_hC
	};
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	//	jbgf[^
	//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
	typedef struct UNIT_PARAM {
		CString			stCommander;					//	
		CString			stSoldier;						//	
		long			lRDj_At;						//	{_UC
		long			lRDj_Df;						//	{_hC
		long			lRAt_At;						//	U_UC
		long			lRAt_Df;						//	U_hC
		long			lRDf_At;						//	h䎞_UC
		long			lRDf_Df;						//	h䎞_hC
		short			sNo;							//	jbgNo
		WORD			wU_HP;							//	m
		WORD			wU_MaxHP;						//	ő啺m
		WORD			wU_At;							//	U
		WORD			wU_Df;							//	h
		WORD			wU_RP;							//	񕜐
		WORD			wAt;							//	U
		WORD			wDf;							//	h
		WORD			wAtT;							//	U
		WORD			wHP;							//	HP
		WORD			wMaxHP;							//	őHP
		WORD			wOp;							//	퐬m
		WORD			wMg;							//	@́^@h
		WORD			wFlag;							//	tO
		WORD			wEx;							//	݂̌on
		WORD			wLv;							//	퓬LV
		//==============================================================
		//	f[^̓ǂݍ
		//==============================================================
		void Load(
			const LPBYTE lpData,						//IN	:ASDoCi
			const int iUnitNo							//IN	:CharNo
		) {
			ASSERT(lpData != NULL && sNo < eUnit_Num);
			sNo			= iUnitNo;
			int	iOffset	= eName_Offset * sNo;
#if defined(UNICODE) || defined(_UNICODE)
			char	cBuffer[eName_Length + 1];
			cBuffer[eName_Length]	= '\0';
			strncpy(cBuffer, reinterpret_cast<LPCSTR>(&lpData[eCommander + iOffset]), eName_Length);
			stCommander	= cBuffer;
			strncpy(cBuffer, reinterpret_cast<LPCSTR>(&lpData[eSoldier + iOffset]), eName_Length);
			stSoldier	= cBuffer;
#else
			_mbsnbcpy(reinterpret_cast<LPBYTE>(stCommander.GetBuffer(eName_Length)), &lpData[eCommander + iOffset], eName_Length);
			stCommander.ReleaseBuffer();
			_mbsnbcpy(reinterpret_cast<LPBYTE>(stSoldier.GetBuffer(eName_Length)), &lpData[eSoldier + iOffset], eName_Length);
			stSoldier.ReleaseBuffer();
#endif
			iOffset	= eParam_Offset * sNo;
			lRDj_At	= ConvValueFromASD(*reinterpret_cast<LPWORD>(&lpData[eRDj_At + iOffset]));
			lRDj_Df	= ConvValueFromASD(*reinterpret_cast<LPWORD>(&lpData[eRDj_Df + iOffset]));
			lRAt_At	= ConvValueFromASD(*reinterpret_cast<LPWORD>(&lpData[eRAt_At + iOffset]));
			lRAt_Df	= ConvValueFromASD(*reinterpret_cast<LPWORD>(&lpData[eRAt_Df + iOffset]));
			lRDf_At	= ConvValueFromASD(*reinterpret_cast<LPWORD>(&lpData[eRDf_At + iOffset]));
			lRDf_Df	= ConvValueFromASD(*reinterpret_cast<LPWORD>(&lpData[eRDf_Df + iOffset]));
			wU_At		= *reinterpret_cast<LPWORD>(&lpData[eU_At + iOffset]);
			wU_Df		= *reinterpret_cast<LPWORD>(&lpData[eU_Df + iOffset]);
			wU_HP		= *reinterpret_cast<LPWORD>(&lpData[eU_HP + iOffset]);
			wU_MaxHP	= *reinterpret_cast<LPWORD>(&lpData[eU_MaxHP + iOffset]);
			wU_RP		= *reinterpret_cast<LPWORD>(&lpData[eU_RP + iOffset]);
			wAt			= *reinterpret_cast<LPWORD>(&lpData[eAt + iOffset]);
			wDf			= *reinterpret_cast<LPWORD>(&lpData[eDf + iOffset]);
			wAtT		= *reinterpret_cast<LPWORD>(&lpData[eAtT + iOffset]);
			wHP			= *reinterpret_cast<LPWORD>(&lpData[eHP + iOffset]);
			wMaxHP		= *reinterpret_cast<LPWORD>(&lpData[eMaxHP + iOffset]);
			wOp			= *reinterpret_cast<LPWORD>(&lpData[eOp + iOffset]);
			wMg			= *reinterpret_cast<LPWORD>(&lpData[eMg + iOffset]);
			wFlag		= *reinterpret_cast<LPWORD>(&lpData[eFlag + iOffset]);
			wEx			= *reinterpret_cast<LPWORD>(&lpData[eEx + iOffset]);
			wLv			= *reinterpret_cast<LPWORD>(&lpData[eLv + iOffset]);
		}
		//==============================================================
		//	f[^̏
		//==============================================================
		void Write(
			LPBYTE lpData								//IN	:ASDoCi
		) {
			ASSERT(lpData != NULL);
			int	iOffset	= eName_Offset * sNo;
#if defined(UNICODE) || defined(_UNICODE)
			char	cBuffer[eName_Length + 1];
			::WideCharToMultiByte(CP_ACP, 0, stCommander, -1, cBuffer, eName_Length + 1, NULL, NULL);
			strncpy(reinterpret_cast<LPSTR>(&lpData[eCommander + iOffset]), cBuffer, eName_Length);
			::WideCharToMultiByte(CP_ACP, 0, stSoldier, -1, cBuffer, eName_Length + 1, NULL, NULL);
			strncpy(reinterpret_cast<LPSTR>(&lpData[eSoldier + iOffset]), cBuffer, eName_Length);
#else
			_mbsnbcpy(&lpData[eCommander + iOffset], reinterpret_cast<const unsigned char*>(static_cast<LPCSTR>(stCommander)), eName_Length);
			_mbsnbcpy(&lpData[eSoldier + iOffset], reinterpret_cast<const unsigned char*>(static_cast<LPCSTR>(stSoldier)), eName_Length);
#endif
			iOffset	= eParam_Offset * sNo;
			*reinterpret_cast<LPWORD>(&lpData[eRDj_At + iOffset])	= ConvValueToASD(lRDj_At);
			*reinterpret_cast<LPWORD>(&lpData[eRDj_Df + iOffset])	= ConvValueToASD(lRDj_Df);
			*reinterpret_cast<LPWORD>(&lpData[eRAt_At + iOffset])	= ConvValueToASD(lRAt_At);
			*reinterpret_cast<LPWORD>(&lpData[eRAt_Df + iOffset])	= ConvValueToASD(lRAt_Df);
			*reinterpret_cast<LPWORD>(&lpData[eRDf_At + iOffset])	= ConvValueToASD(lRDf_At);
			*reinterpret_cast<LPWORD>(&lpData[eRDf_Df + iOffset])	= ConvValueToASD(lRDf_Df);
			*reinterpret_cast<LPWORD>(&lpData[eU_At + iOffset])		= wU_At;
			*reinterpret_cast<LPWORD>(&lpData[eU_Df + iOffset])		= wU_Df;
			*reinterpret_cast<LPWORD>(&lpData[eU_HP + iOffset])		= wU_HP;
			*reinterpret_cast<LPWORD>(&lpData[eU_MaxHP + iOffset])	= wU_MaxHP;
			*reinterpret_cast<LPWORD>(&lpData[eU_RP + iOffset])		= wU_RP;
			*reinterpret_cast<LPWORD>(&lpData[eAt + iOffset])		= wAt;
			*reinterpret_cast<LPWORD>(&lpData[eDf + iOffset])		= wDf;
			*reinterpret_cast<LPWORD>(&lpData[eAtT + iOffset])		= wAtT;
			*reinterpret_cast<LPWORD>(&lpData[eHP + iOffset])		= wHP;
			*reinterpret_cast<LPWORD>(&lpData[eMaxHP + iOffset])	= wMaxHP;
			*reinterpret_cast<LPWORD>(&lpData[eOp + iOffset])		= wOp;
			*reinterpret_cast<LPWORD>(&lpData[eMg + iOffset])		= wMg;
			*reinterpret_cast<LPWORD>(&lpData[eFlag + iOffset])		= wFlag;
			*reinterpret_cast<LPWORD>(&lpData[eEx + iOffset])		= wEx;
			*reinterpret_cast<LPWORD>(&lpData[eLv + iOffset])		= wLv;
		}
		//==============================================================
		//	ASDl -> 10il
		//==============================================================
		long ConvValueFromASD(							//OUT	:10il
			const WORD wData							//IN	:ASDl
		) {
			return (wData < 0x0a ? wData : -(wData - 0x0a));
		}
		//==============================================================
		//	10il -> ASDl
		//==============================================================
		WORD ConvValueToASD(							//OUT	:ASDl
			const long lData							//IN	:10il
		) {
			return (lData >= 0 ? min(lData, 9) : 0x0a - max(lData, -65525));
		}
	}	*LPUNIT_PARAM;

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%																		%%
//%%								ρ@									%%
//%%																		%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
protected:
	CPtrArray			arrMUnit;						//	jbgf[^
	CString				stMAsdPath;						//	ݑ쒆ASDt@CpX
	HICON				hMIcon;							//	ACR
	BOOL				fMAutoUpdate;					//	TRUE=XVAFALSE=
	BOOL				fMModified;						//	TRUE=f[^ύXAFALSE=
	int					iMSelectUnitNo;					//	ݑI𒆂̃jbgNo

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%																		%%
//%%								ց@									%%
//%%																		%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
public:
//==============================================================
//	RXgN^
//==============================================================
KitikuoDlgC(
	CWnd* pParent = NULL								//IN	:eEBhẼ|C^
);
//==============================================================
//	fXgN^
//==============================================================
virtual ~KitikuoDlgC();

protected:
//==============================================================
//	J
//==============================================================
void Release();
//==============================================================
//	f[^̍XViASD -> ʂցj
//==============================================================
void UpdateFromAsd(
	const int iIndex									//IN	:Xg{bNXindex
);
//==============================================================
//	f[^̍XVi -> ASDցj
//==============================================================
void UpdateToAsd(
	const int iIndex									//IN	:Xg{bNXindex
);
//==============================================================
//	UIXV
//==============================================================
void UpdateUI();
//==============================================================
//	Xg{bNXɓo^
//==============================================================
BOOL AddUnitToList(										//OUT	:
	int iIndex,											//IN	:index
	LPUNIT_PARAM lpPM									//IN	:32Bitf[^
);
//==============================================================
//	Xg{bNX̐ݒ
//==============================================================
void SetListBoxHorizontalExtent();

//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
//%%																		%%
//%%								leb									%%
//%%																		%%
//%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
public:
	//{{AFX_DATA(KitikuoDlgC)
	enum { IDD = IDD_KITIKUO_DIALOG };
	CListBox	m_lst_unit;
	//}}AFX_DATA

	//{{AFX_VIRTUAL(KitikuoDlgC)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV ̃T|[g
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(KitikuoDlgC)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnFileOpen();
	afx_msg void OnFileSave();
	afx_msg void OnAutoUpdate();
	afx_msg void OnAppAbout();
	afx_msg void OnSelchangeListUnit();
	afx_msg void OnButtonUpdate();
	//}}AFX_MSG
	afx_msg void OnChangeEditName(UINT nID);
	afx_msg void OnChangeEditParam(UINT nID);
	DECLARE_MESSAGE_MAP()

};

//{{AFX_INSERT_LOCATION}}

#endif
